gp-grid-logo
Examples

Row Dragging

Allow users to reorder rows in the React grid via drag-and-drop, with handle-based dragging, drop indicators, and event hooks for persistence logic today.

gp-grid supports row reordering via drag and drop. You can either designate a column as a drag handle or allow dragging from any cell.

Interactive Demo

Toggle between drag handle mode and entire row mode. Drag rows to reorder them.

Drag Handle Column

Set rowDrag: true on a column to make it act as a drag handle:

RowDraggingGrid.tsx
import { useCallback } from "react";
import {
  Grid,
  useGridData,
  type ColumnDefinition,
} from "@gp-grid/react";

const columns: ColumnDefinition[] = [
  { field: "id", cellDataType: "number", width: 40, rowDrag: true, sortable: false },
  { field: "task", cellDataType: "text", width: 200, headerName: "Task" },
  { field: "assignee", cellDataType: "text", width: 120, headerName: "Assignee" },
  { field: "status", cellDataType: "text", width: 100, headerName: "Status" },
];

function RowDraggingGrid() {
  const { dataSource } = useGridData(initialData, {
    getRowId: (row) => row.id,
  });

  const handleRowDragEnd = useCallback(
    (sourceIndex: number, targetIndex: number) => {
      dataSource.moveRow(sourceIndex, targetIndex);
    },
    [dataSource]
  );

  return (
    <div style={{ height: "400px" }}>
      <Grid
        columns={columns}
        dataSource={dataSource}
        rowHeight={36}
        onRowDragEnd={handleRowDragEnd}
      />
    </div>
  );
}

Entire Row Dragging

Set rowDragEntireRow={true} on the Grid to allow dragging from any cell:

<Grid
  columns={columns}
  dataSource={dataSource}
  rowHeight={36}
  rowDragEntireRow={true}
  onRowDragEnd={handleRowDragEnd}
/>

When rowDragEntireRow is enabled, clicking and dragging any cell initiates a row drag instead of a cell selection.

Data Reordering

The consumer is responsible for reordering data after a drag. Call dataSource.moveRow() from the useGridData hook:

const { dataSource } = useGridData(data, {
  getRowId: (row) => row.id,
});

const handleRowDragEnd = (sourceIndex: number, targetIndex: number) => {
  dataSource.moveRow(sourceIndex, targetIndex);
};

How It Works

  1. Click and hold a drag handle (or any cell if rowDragEntireRow is enabled)
  2. Drag up or down — a drop indicator line shows the target position
  3. Release to drop the row
  4. onRowDragEnd fires with sourceIndex and targetIndex
  5. Call dataSource.moveRow() to reorder the data

Key Points

  • Use rowDrag: true on a column for a dedicated drag handle
  • Use rowDragEntireRow={true} on the Grid to drag from any cell
  • The drop indicator works correctly with virtual scrolling, even with millions of rows
  • Always use a mutable data source via useGridData for row reordering
  • The onRowDragEnd callback provides display indices — the data source handles the mapping

gp-grid-logo
Examples

Row Dragging

Allow users to reorder rows in the Vue 3 grid via drag-and-drop, with handle-based dragging, drop indicators, and event hooks for persistence logic today.

gp-grid supports row reordering via drag and drop. You can designate a column as a drag handle or allow dragging from any cell.

Interactive Demo

Drag Handle Column

Set rowDrag: true on a column to make it act as a drag handle:

<script setup lang="ts">
import { Grid, useGridData, type ColumnDefinition } from "@gp-grid/vue";

const columns: ColumnDefinition[] = [
  { field: "id", cellDataType: "number", width: 40, rowDrag: true, sortable: false },
  { field: "task", cellDataType: "text", width: 200, headerName: "Task" },
  { field: "assignee", cellDataType: "text", width: 120, headerName: "Assignee" },
  { field: "status", cellDataType: "text", width: 100, headerName: "Status" },
];

const { dataSource } = useGridData(initialData, {
  getRowId: (row) => row.id,
});

function handleRowDragEnd(sourceIndex: number, targetIndex: number) {
  dataSource.moveRow(sourceIndex, targetIndex);
}
</script>

<template>
  <div style="height: 400px">
    <Grid
      :columns="columns"
      :data-source="dataSource"
      :row-height="36"
      @row-drag-end="handleRowDragEnd"
    />
  </div>
</template>

Entire Row Dragging

Set row-drag-entire-row to allow dragging from any cell:

<template>
  <Grid
    :columns="columns"
    :data-source="dataSource"
    :row-height="36"
    :row-drag-entire-row="true"
    @row-drag-end="handleRowDragEnd"
  />
</template>

Data Reordering

The consumer is responsible for reordering data. Call dataSource.moveRow() from the useGridData composable:

<script setup lang="ts">
const { dataSource } = useGridData(data, {
  getRowId: (row) => row.id,
});

function handleRowDragEnd(sourceIndex: number, targetIndex: number) {
  dataSource.moveRow(sourceIndex, targetIndex);
}
</script>

Key Points

  • Use rowDrag: true on a column for a dedicated drag handle
  • Use :row-drag-entire-row="true" to drag from any cell
  • Always use a mutable data source via useGridData for row reordering
  • The drop indicator works correctly with virtual scrolling

gp-grid-logo
Examples

Row Dragging

Allow users to reorder rows in the Angular grid via drag-and-drop, with handle-based dragging, drop indicators, and event hooks for persistence logic.

Reorder rows with a drag handle or by dragging the entire row.

Interactive Demo

Angular-specific code samples below.

draggable-rows-grid.component.ts
import { Component } from "@angular/core";
import { GridComponent, type ColumnDefinition } from "@gp-grid/angular";

@Component({
  selector: "app-draggable-rows-grid",
  standalone: true,
  imports: [GridComponent],
  template: `
    <div style="height: 400px">
      <gp-grid
        [columns]="columns"
        [rowData]="data"
        [rowHeight]="36"
        [rowDraggable]="true"
      />
    </div>
  `,
})
export class DraggableRowsGridComponent {
  columns: ColumnDefinition[] = [/* ... */];
  data = [/* ... */];
}